﻿#light

// Use existing Control.
open System
open System.Windows.Forms

// The tree type
type 'a Tree =
    | Node of 'a Tree * 'a Tree
    | Leaf of 'a
    
// Define a tree
let tree =
    Node(
        Node(
            Leaf "One",
            Node(Leaf "Two", Leaf "Three")),
        Node(
            Node(Leaf "Four", Leaf "Five"),
            Leaf "Six")
        )
        
let bindTreeView source = 
    let rec mapToTreeNode s (node: TreeNode) =
        match s with
        | Node (l, r) -> 
            let newNode = new TreeNode("Node")
            node.Nodes.Add(newNode) |> ignore
            mapToTreeNode l newNode
            mapToTreeNode r newNode
        | Leaf x ->
            node.Nodes.Add(new TreeNode(any_to_string x)) |> ignore
            
    let rootNode = new TreeNode("Root")
    mapToTreeNode source rootNode
    rootNode
    
// Create the form.
let form =
    let temp = new Form()
    let treeView = new TreeView(Dock = DockStyle.Fill)
    treeView.Nodes.Add(bindTreeView tree) |> ignore
    treeView.ExpandAll()
    temp.Controls.Add(treeView)
    temp
   
[<STAThread>] 
do Application.Run(form)